.386                                                     ; minimum processor
.model flat,stdcall                                      ; win32 application
option casemap:none                                      ; case sensitive

include windows.inc                                      ; win32 structures etc.

incboth macro incl                                       ; macro for lazy coders
  include    incl.inc
  includelib incl.lib
endm

; ** includes
incboth kernel32                                         ; functions from kernel32
incboth user32                                           ; functions from user32
incboth comctl32                                         ; functions from comctl32
incboth advapi32                                         ; token access

; ** function prototypes
DlgProc           PROTO :HWND,:UINT,:WPARAM,:LPARAM      ; main dialog procedure
TV_INIT           proto :DWORD, :DWORD, :DWORD, :DWORD   ; init the treeview
TV_UPDATE         proto :DWORD, :DWORD                   ; get informations from system
INFO_SHOW         proto :DWORD, :DWORD, :DWORD, :DWORD   ; display an info

; ** uninitialized data
.data?
hInstance            HINSTANCE      ?                    ; application instance
hIcon                HICON          ?                    ; application icon 
hSnapShot            DD             ?                    ; general snapshot handle 
hSnapShot2           DD             ?                    ; process snapshot handle
myProcess            PROCESSENTRY32 <>                   ; process structure
myModule             MODULEENTRY32  <>                   ; module structure
myHeapList           HEAPLIST32     <>                   ; heaplist entry
myThread             THREADENTRY32  <>                   ; thread entry                    
mytvi                TV_INSERTSTRUCT <>                  ; treeviewstruct 
_hProcess            dd ?                                ; NT ONLY
_hToken              dd ?                                ; NT ONLY
tkp                  TOKEN_PRIVILEGES <>                 ; NT ONLY
myBuffer             DB 100 DUP (?)                      ; converter buffer
myCatBuffer          DB 512 DUP (?)                      ; sting cat buffer

; ** initialized data
.data
szAppName            db "ProcessViewer 1.05 by Pegasus[REN]",0 ; dialog caption
szTemplateDWORD      db "%08lXh ",0                      ; hex template
szString             db "SeDebugPrivilege",0             ; NT ONLY 

; ** process related informations
szProcessInfo        db "ProcessInformation",0           ; heading for main information
szProcessID          db "%08lX ProcessID",0
szParentProcessID    db "%08lX ParentProcessID",0
szDefaultHeapID      db "%08lX DefaultHeapID",0
szModuleID           db "%08lX ModuleID",0
szNumOfThreads       db "%08lX NumberOfThreads",0
szNumOfUsers         db "%08lX NumberOfUsers",0
szBasePrioity        db "%08lX BasePriority",0
szProcessFlags       db "%08lX Flags",0

; ** module related informations
szModuleInfo         db "ModuleInformation",0            ; heading for module information
;szModuleID           db "%08lX ModuleID",0              ; exists in process info !!
szModuleHandle       db "%08lX ModuleHandle",0
szGlobalUsage        db "%08lX GlobalUsage",0
szProcessUsage       db "%08lX ProcessUsage",0

; ** thread related informations
szThreadInfo         db "ThreadInformation",0            ; heading for thread information
szThreadID           db "%08lX ThreadID",0

; ** heap related informations
szHeapInfo           db "HeapInformation",0              ; heading for heap information
szHeapID             db "%08lX HeapID",0


; ** constants
.const
IDI_ICON             equ 100                             ; application icon
IDD_DIALOG           equ 1000                            ; dialog resource
IDC_TREEVIEW         equ 1001                            ; process treeview
IDC_UPDATE           equ 1002                            ; update button
